<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>PurgeTxnLog.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">PurgeTxnLog.java</span></div><h1>PurgeTxnLog.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.io.File;
import java.io.FileFilter;
import java.io.IOException;
import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.apache.zookeeper.server.persistence.FileTxnSnapLog;
import org.apache.zookeeper.server.persistence.Util;

/**
 * this class is used to clean up the 
 * snapshot and data log dir's. This is usually
 * run as a cronjob on the zookeeper server machine.
 * Invocation of this class will clean up the datalogdir
 * files and snapdir files keeping the last &quot;-n&quot; snapshot files
 * and the corresponding logs.
 */
<span class="nc" id="L40">public class PurgeTxnLog {</span>

    private static final String COUNT_ERR_MSG = &quot;count should be greater than or equal to 3&quot;;

    static void printUsage(){
<span class="nc" id="L45">        System.out.println(&quot;Usage:&quot;);</span>
<span class="nc" id="L46">        System.out.println(&quot;PurgeTxnLog dataLogDir [snapDir] -n count&quot;);</span>
<span class="nc" id="L47">        System.out.println(&quot;\tdataLogDir -- path to the txn log directory&quot;);</span>
<span class="nc" id="L48">        System.out.println(&quot;\tsnapDir -- path to the snapshot directory&quot;);</span>
<span class="nc" id="L49">        System.out.println(&quot;\tcount -- the number of old snaps/logs you want &quot; +</span>
            &quot;to keep, value should be greater than or equal to 3&quot;);
<span class="nc" id="L51">    }</span>

    private static final String PREFIX_SNAPSHOT = &quot;snapshot&quot;;
    private static final String PREFIX_LOG = &quot;log&quot;;

    /**
     * Purges the snapshot and logs keeping the last num snapshots and the
     * corresponding logs. If logs are rolling or a new snapshot is created
     * during this process, these newest N snapshots or any data logs will be
     * excluded from current purging cycle.
     *
     * @param dataDir the dir that has the logs
     * @param snapDir the dir that has the snapshots
     * @param num the number of snapshots to keep
     * @throws IOException
     */
    public static void purge(File dataDir, File snapDir, int num) throws IOException {
<span class="pc bpc" id="L68" title="1 of 2 branches missed.">        if (num &lt; 3) {</span>
<span class="nc" id="L69">            throw new IllegalArgumentException(COUNT_ERR_MSG);</span>
        }

<span class="fc" id="L72">        FileTxnSnapLog txnLog = new FileTxnSnapLog(dataDir, snapDir);</span>

<span class="fc" id="L74">        List&lt;File&gt; snaps = txnLog.findNRecentSnapshots(num);</span>
<span class="fc" id="L75">        retainNRecentSnapshots(txnLog, snaps);</span>
<span class="fc" id="L76">    }</span>

    // VisibleForTesting
    static void retainNRecentSnapshots(FileTxnSnapLog txnLog, List&lt;File&gt; snaps) {
        // found any valid recent snapshots?
<span class="pc bpc" id="L81" title="1 of 2 branches missed.">        if (snaps.size() == 0)</span>
<span class="nc" id="L82">            return;</span>
<span class="fc" id="L83">        File snapShot = snaps.get(snaps.size() -1);</span>
<span class="fc" id="L84">        final long leastZxidToBeRetain = Util.getZxidFromName(</span>
<span class="fc" id="L85">                snapShot.getName(), PREFIX_SNAPSHOT);</span>

        class MyFileFilter implements FileFilter{
            private final String prefix;
<span class="fc" id="L89">            MyFileFilter(String prefix){</span>
<span class="fc" id="L90">                this.prefix=prefix;</span>
<span class="fc" id="L91">            }</span>
            public boolean accept(File f){
<span class="fc bfc" id="L93" title="All 2 branches covered.">                if(!f.getName().startsWith(prefix + &quot;.&quot;))</span>
<span class="fc" id="L94">                    return false;</span>
<span class="fc" id="L95">                long fZxid = Util.getZxidFromName(f.getName(), prefix);</span>
<span class="fc bfc" id="L96" title="All 2 branches covered.">                if (fZxid &gt;= leastZxidToBeRetain) {</span>
<span class="fc" id="L97">                    return false;</span>
                }
<span class="fc" id="L99">                return true;</span>
            }
        }
        // add all non-excluded log files
<span class="fc" id="L103">        List&lt;File&gt; files = new ArrayList&lt;File&gt;(Arrays.asList(txnLog</span>
<span class="fc" id="L104">                .getDataDir().listFiles(new MyFileFilter(PREFIX_LOG))));</span>
        // add all non-excluded snapshot files to the deletion list
<span class="fc" id="L106">        files.addAll(Arrays.asList(txnLog.getSnapDir().listFiles(</span>
                new MyFileFilter(PREFIX_SNAPSHOT))));
        // remove the old files
<span class="fc bfc" id="L109" title="All 2 branches covered.">        for(File f: files)</span>
        {
<span class="fc" id="L111">            System.out.println(&quot;Removing file: &quot;+</span>
<span class="fc" id="L112">                DateFormat.getDateTimeInstance().format(f.lastModified())+</span>
<span class="fc" id="L113">                &quot;\t&quot;+f.getPath());</span>
<span class="pc bpc" id="L114" title="1 of 2 branches missed.">            if(!f.delete()){</span>
<span class="nc" id="L115">                System.err.println(&quot;Failed to remove &quot;+f.getPath());</span>
            }
<span class="fc" id="L117">        }</span>

<span class="fc" id="L119">    }</span>
    
    /**
     * @param args dataLogDir [snapDir] -n count
     * dataLogDir -- path to the txn log directory
     * snapDir -- path to the snapshot directory
     * count -- the number of old snaps/logs you want to keep, value should be greater than or equal to 3&lt;br&gt;
     */
    public static void main(String[] args) throws IOException {
<span class="pc bpc" id="L128" title="2 of 4 branches missed.">        if (args.length &lt; 3 || args.length &gt; 4) {</span>
<span class="nc" id="L129">            printUsageThenExit();</span>
        }
<span class="fc" id="L131">        File dataDir = validateAndGetFile(args[0]);</span>
<span class="fc" id="L132">        File snapDir = dataDir;</span>
<span class="fc" id="L133">        int num = -1;</span>
<span class="fc" id="L134">        String countOption = &quot;&quot;;</span>
<span class="fc bfc" id="L135" title="All 2 branches covered.">        if (args.length == 3) {</span>
<span class="fc" id="L136">            countOption = args[1];</span>
<span class="fc" id="L137">            num = validateAndGetCount(args[2]);</span>
        } else {
<span class="fc" id="L139">            snapDir = validateAndGetFile(args[1]);</span>
<span class="fc" id="L140">            countOption = args[2];</span>
<span class="fc" id="L141">            num = validateAndGetCount(args[3]);</span>
        }
<span class="pc bpc" id="L143" title="1 of 2 branches missed.">        if (!&quot;-n&quot;.equals(countOption)) {</span>
<span class="nc" id="L144">            printUsageThenExit();</span>
        }
<span class="fc" id="L146">        purge(dataDir, snapDir, num);</span>
<span class="fc" id="L147">    }</span>

    /**
     * validates file existence and returns the file
     *
     * @param path
     * @return File
     */
    private static File validateAndGetFile(String path) {
<span class="fc" id="L156">        File file = new File(path);</span>
<span class="pc bpc" id="L157" title="1 of 2 branches missed.">        if (!file.exists()) {</span>
<span class="nc" id="L158">            System.err.println(&quot;Path '&quot; + file.getAbsolutePath()</span>
                    + &quot;' does not exist. &quot;);
<span class="nc" id="L160">            printUsageThenExit();</span>
        }
<span class="fc" id="L162">        return file;</span>
    }

    /**
     * Returns integer if parsed successfully and it is valid otherwise prints
     * error and usage and then exits
     *
     * @param number
     * @return
     */
    private static int validateAndGetCount(String number) {
<span class="fc" id="L173">        int result = 0;</span>
        try {
<span class="fc" id="L175">            result = Integer.parseInt(number);</span>
<span class="pc bpc" id="L176" title="1 of 2 branches missed.">            if (result &lt; 3) {</span>
<span class="nc" id="L177">                System.err.println(COUNT_ERR_MSG);</span>
<span class="nc" id="L178">                printUsageThenExit();</span>
            }
<span class="nc" id="L180">        } catch (NumberFormatException e) {</span>
<span class="nc" id="L181">            System.err</span>
<span class="nc" id="L182">                    .println(&quot;'&quot; + number + &quot;' can not be parsed to integer.&quot;);</span>
<span class="nc" id="L183">            printUsageThenExit();</span>
<span class="fc" id="L184">        }</span>
<span class="fc" id="L185">        return result;</span>
    }

    private static void printUsageThenExit() {
<span class="nc" id="L189">        printUsage();</span>
<span class="nc" id="L190">        System.exit(1);</span>
<span class="nc" id="L191">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>